# coding: utf-8

# flake8: noqa

"""
    PTV Timetable API - Version 3

    The PTV Timetable API provides direct access to Public Transport Victoria’s public transport timetable data.    The API returns scheduled timetable, route and stop data for all metropolitan and regional train, tram and bus services in Victoria, including Night Network(Night Train and Night Tram data are included in metropolitan train and tram services data, respectively, whereas Night Bus is a separate route type).    The API also returns real-time data for metropolitan train, tram and bus services (where this data is made available to PTV), as well as disruption information, stop facility information, and access to myki ticket outlet data.    This Swagger is for Version 3 of the PTV Timetable API. By using this documentation you agree to comply with the licence and terms of service.    Train timetable data is updated daily, while the remaining data is updated weekly, taking into account any planned timetable changes (for example, due to holidays or planned disruptions). The PTV timetable API is the same API used by PTV for its apps. To access the most up to date data PTV has (including real-time data) you must use the API dynamically.    You can access the PTV Timetable API through a HTTP or HTTPS interface, as follows:        base URL / version number / API name / query string  The base URL is either:    *  http://timetableapi.ptv.vic.gov.au  or    *  https://timetableapi.ptv.vic.gov.au    The Swagger JSON file is available at http://timetableapi.ptv.vic.gov.au/swagger/docs/v3    Frequently asked questions are available on the PTV website at http://ptv.vic.gov.au/apifaq    Links to the following information are also provided on the PTV website at http://ptv.vic.gov.au/ptv-timetable-api/  * How to register for an API key and calculate a signature  * PTV Timetable API V2 to V3 Migration Guide  * Documentation for Version 2 of the PTV Timetable API  * PTV Timetable API Data Quality Statement    All information about how to use the API is in this documentation. PTV cannot provide technical support for the API.    Credits: This page has been based on Steve Bennett's http://opentransportdata.org/, used with permission.    # noqa: E501

    OpenAPI spec version: v3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# import apis into sdk package
from ptvapi.api.departures_api import DeparturesApi
from ptvapi.api.directions_api import DirectionsApi
from ptvapi.api.disruptions_api import DisruptionsApi
from ptvapi.api.outlets_api import OutletsApi
from ptvapi.api.patterns_api import PatternsApi
from ptvapi.api.route_types_api import RouteTypesApi
from ptvapi.api.routes_api import RoutesApi
from ptvapi.api.runs_api import RunsApi
from ptvapi.api.search_api import SearchApi
from ptvapi.api.stops_api import StopsApi

# import ApiClient
from ptvapi.api_client import ApiClient
from ptvapi.configuration import Configuration
# import models into sdk package
from ptvapi.models.v2_object import V2Object
from ptvapi.models.v3_bulk_departures_request import V3BulkDeparturesRequest
from ptvapi.models.v3_bulk_departures_response import V3BulkDeparturesResponse
from ptvapi.models.v3_bulk_departures_route_direction_response import V3BulkDeparturesRouteDirectionResponse
from ptvapi.models.v3_bulk_departures_stop_response import V3BulkDeparturesStopResponse
from ptvapi.models.v3_bulk_departures_update_response import V3BulkDeparturesUpdateResponse
from ptvapi.models.v3_departure import V3Departure
from ptvapi.models.v3_departures_broad_parameters import V3DeparturesBroadParameters
from ptvapi.models.v3_departures_response import V3DeparturesResponse
from ptvapi.models.v3_departures_specific_parameters import V3DeparturesSpecificParameters
from ptvapi.models.v3_direction import V3Direction
from ptvapi.models.v3_direction_with_description import V3DirectionWithDescription
from ptvapi.models.v3_directions_response import V3DirectionsResponse
from ptvapi.models.v3_disruption import V3Disruption
from ptvapi.models.v3_disruption_direction import V3DisruptionDirection
from ptvapi.models.v3_disruption_mode import V3DisruptionMode
from ptvapi.models.v3_disruption_modes_response import V3DisruptionModesResponse
from ptvapi.models.v3_disruption_response import V3DisruptionResponse
from ptvapi.models.v3_disruption_route import V3DisruptionRoute
from ptvapi.models.v3_disruption_stop import V3DisruptionStop
from ptvapi.models.v3_disruptions import V3Disruptions
from ptvapi.models.v3_disruptions_response import V3DisruptionsResponse
from ptvapi.models.v3_error_response import V3ErrorResponse
from ptvapi.models.v3_outlet import V3Outlet
from ptvapi.models.v3_outlet_geolocation import V3OutletGeolocation
from ptvapi.models.v3_outlet_geolocation_parameters import V3OutletGeolocationParameters
from ptvapi.models.v3_outlet_geolocation_response import V3OutletGeolocationResponse
from ptvapi.models.v3_outlet_parameters import V3OutletParameters
from ptvapi.models.v3_outlet_response import V3OutletResponse
from ptvapi.models.v3_result_outlet import V3ResultOutlet
from ptvapi.models.v3_result_route import V3ResultRoute
from ptvapi.models.v3_result_stop import V3ResultStop
from ptvapi.models.v3_route import V3Route
from ptvapi.models.v3_route_departures_specific_parameters import V3RouteDeparturesSpecificParameters
from ptvapi.models.v3_route_response import V3RouteResponse
from ptvapi.models.v3_route_service_status import V3RouteServiceStatus
from ptvapi.models.v3_route_type import V3RouteType
from ptvapi.models.v3_route_types_response import V3RouteTypesResponse
from ptvapi.models.v3_route_with_status import V3RouteWithStatus
from ptvapi.models.v3_run import V3Run
from ptvapi.models.v3_run_response import V3RunResponse
from ptvapi.models.v3_runs_response import V3RunsResponse
from ptvapi.models.v3_search_parameters import V3SearchParameters
from ptvapi.models.v3_search_result import V3SearchResult
from ptvapi.models.v3_status import V3Status
from ptvapi.models.v3_stop_accessibility import V3StopAccessibility
from ptvapi.models.v3_stop_accessibility_wheelchair import V3StopAccessibilityWheelchair
from ptvapi.models.v3_stop_amenity_details import V3StopAmenityDetails
from ptvapi.models.v3_stop_base import V3StopBase
from ptvapi.models.v3_stop_departure_request import V3StopDepartureRequest
from ptvapi.models.v3_stop_departure_request_route_direction import V3StopDepartureRequestRouteDirection
from ptvapi.models.v3_stop_details import V3StopDetails
from ptvapi.models.v3_stop_geosearch import V3StopGeosearch
from ptvapi.models.v3_stop_gps import V3StopGps
from ptvapi.models.v3_stop_location import V3StopLocation
from ptvapi.models.v3_stop_on_route import V3StopOnRoute
from ptvapi.models.v3_stop_response import V3StopResponse
from ptvapi.models.v3_stop_staffing import V3StopStaffing
from ptvapi.models.v3_stopping_pattern import V3StoppingPattern
from ptvapi.models.v3_stops_by_distance_response import V3StopsByDistanceResponse
from ptvapi.models.v3_stops_on_route_response import V3StopsOnRouteResponse
from ptvapi.models.v3_vehicle_descriptor import V3VehicleDescriptor
from ptvapi.models.v3_vehicle_position import V3VehiclePosition
