# coding: utf-8

"""
    PTV Timetable API - Version 3

    The PTV Timetable API provides direct access to Public Transport Victoria’s public transport timetable data.    The API returns scheduled timetable, route and stop data for all metropolitan and regional train, tram and bus services in Victoria, including Night Network(Night Train and Night Tram data are included in metropolitan train and tram services data, respectively, whereas Night Bus is a separate route type).    The API also returns real-time data for metropolitan train, tram and bus services (where this data is made available to PTV), as well as disruption information, stop facility information, and access to myki ticket outlet data.    This Swagger is for Version 3 of the PTV Timetable API. By using this documentation you agree to comply with the licence and terms of service.    Train timetable data is updated daily, while the remaining data is updated weekly, taking into account any planned timetable changes (for example, due to holidays or planned disruptions). The PTV timetable API is the same API used by PTV for its apps. To access the most up to date data PTV has (including real-time data) you must use the API dynamically.    You can access the PTV Timetable API through a HTTP or HTTPS interface, as follows:        base URL / version number / API name / query string  The base URL is either:    *  http://timetableapi.ptv.vic.gov.au  or    *  https://timetableapi.ptv.vic.gov.au    The Swagger JSON file is available at http://timetableapi.ptv.vic.gov.au/swagger/docs/v3    Frequently asked questions are available on the PTV website at http://ptv.vic.gov.au/apifaq    Links to the following information are also provided on the PTV website at http://ptv.vic.gov.au/ptv-timetable-api/  * How to register for an API key and calculate a signature  * PTV Timetable API V2 to V3 Migration Guide  * Documentation for Version 2 of the PTV Timetable API  * PTV Timetable API Data Quality Statement    All information about how to use the API is in this documentation. PTV cannot provide technical support for the API.    Credits: This page has been based on Steve Bennett's http://opentransportdata.org/, used with permission.    # noqa: E501

    OpenAPI spec version: v3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ptvapi.api_client import ApiClient


class SearchApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def search_search(self, search_term, **kwargs):  # noqa: E501
        """View stops, routes and myki ticket outlets that match the search term  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search_search(search_term, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str search_term: Search text (note: if search text is numeric and/or less than 3 characters, the API will only return routes) (required)
        :param list[int] route_types: Filter by route_type; values returned via RouteTypes API (note: stops and routes are ordered by route_types specified)
        :param float latitude: Filter by geographic coordinate of latitude
        :param float longitude: Filter by geographic coordinate of longitude
        :param float max_distance: Filter by maximum distance (in metres) from location specified via latitude and longitude parameters
        :param bool include_addresses: Placeholder for future development; currently unavailable
        :param bool include_outlets: Indicates if outlets will be returned in response (default = true)
        :param bool match_stop_by_suburb: Indicates whether to find stops by suburbs in the search term (default = true)
        :param bool match_route_by_suburb: Indicates whether to find routes by suburbs in the search term (default = true)
        :param bool match_stop_by_gtfs_stop_id: Indicates whether to search for stops according to a metlink stop ID (default = false)
        :param str token: Please ignore
        :param str devid: Your developer id
        :param str signature: Authentication signature for request
        :return: V3SearchResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.search_search_with_http_info(search_term, **kwargs)  # noqa: E501
        else:
            (data) = self.search_search_with_http_info(search_term, **kwargs)  # noqa: E501
            return data

    def search_search_with_http_info(self, search_term, **kwargs):  # noqa: E501
        """View stops, routes and myki ticket outlets that match the search term  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search_search_with_http_info(search_term, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str search_term: Search text (note: if search text is numeric and/or less than 3 characters, the API will only return routes) (required)
        :param list[int] route_types: Filter by route_type; values returned via RouteTypes API (note: stops and routes are ordered by route_types specified)
        :param float latitude: Filter by geographic coordinate of latitude
        :param float longitude: Filter by geographic coordinate of longitude
        :param float max_distance: Filter by maximum distance (in metres) from location specified via latitude and longitude parameters
        :param bool include_addresses: Placeholder for future development; currently unavailable
        :param bool include_outlets: Indicates if outlets will be returned in response (default = true)
        :param bool match_stop_by_suburb: Indicates whether to find stops by suburbs in the search term (default = true)
        :param bool match_route_by_suburb: Indicates whether to find routes by suburbs in the search term (default = true)
        :param bool match_stop_by_gtfs_stop_id: Indicates whether to search for stops according to a metlink stop ID (default = false)
        :param str token: Please ignore
        :param str devid: Your developer id
        :param str signature: Authentication signature for request
        :return: V3SearchResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['search_term', 'route_types', 'latitude', 'longitude', 'max_distance', 'include_addresses', 'include_outlets', 'match_stop_by_suburb', 'match_route_by_suburb', 'match_stop_by_gtfs_stop_id', 'token', 'devid', 'signature']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method search_search" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'search_term' is set
        if ('search_term' not in params or
                params['search_term'] is None):
            raise ValueError("Missing the required parameter `search_term` when calling `search_search`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'search_term' in params:
            path_params['search_term'] = params['search_term']  # noqa: E501

        query_params = []
        if 'route_types' in params:
            query_params.append(('route_types', params['route_types']))  # noqa: E501
            collection_formats['route_types'] = 'multi'  # noqa: E501
        if 'latitude' in params:
            query_params.append(('latitude', params['latitude']))  # noqa: E501
        if 'longitude' in params:
            query_params.append(('longitude', params['longitude']))  # noqa: E501
        if 'max_distance' in params:
            query_params.append(('max_distance', params['max_distance']))  # noqa: E501
        if 'include_addresses' in params:
            query_params.append(('include_addresses', params['include_addresses']))  # noqa: E501
        if 'include_outlets' in params:
            query_params.append(('include_outlets', params['include_outlets']))  # noqa: E501
        if 'match_stop_by_suburb' in params:
            query_params.append(('match_stop_by_suburb', params['match_stop_by_suburb']))  # noqa: E501
        if 'match_route_by_suburb' in params:
            query_params.append(('match_route_by_suburb', params['match_route_by_suburb']))  # noqa: E501
        if 'match_stop_by_gtfs_stop_id' in params:
            query_params.append(('match_stop_by_gtfs_stop_id', params['match_stop_by_gtfs_stop_id']))  # noqa: E501
        if 'token' in params:
            query_params.append(('token', params['token']))  # noqa: E501
        if 'devid' in params:
            query_params.append(('devid', params['devid']))  # noqa: E501
        if 'signature' in params:
            query_params.append(('signature', params['signature']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'text/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v3/search/{search_term}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='V3SearchResult',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
