# coding: utf-8

"""
    PTV Timetable API - Version 3

    The PTV Timetable API provides direct access to Public Transport Victoria’s public transport timetable data.    The API returns scheduled timetable, route and stop data for all metropolitan and regional train, tram and bus services in Victoria, including Night Network(Night Train and Night Tram data are included in metropolitan train and tram services data, respectively, whereas Night Bus is a separate route type).    The API also returns real-time data for metropolitan train, tram and bus services (where this data is made available to PTV), as well as disruption information, stop facility information, and access to myki ticket outlet data.    This Swagger is for Version 3 of the PTV Timetable API. By using this documentation you agree to comply with the licence and terms of service.    Train timetable data is updated daily, while the remaining data is updated weekly, taking into account any planned timetable changes (for example, due to holidays or planned disruptions). The PTV timetable API is the same API used by PTV for its apps. To access the most up to date data PTV has (including real-time data) you must use the API dynamically.    You can access the PTV Timetable API through a HTTP or HTTPS interface, as follows:        base URL / version number / API name / query string  The base URL is either:    *  http://timetableapi.ptv.vic.gov.au  or    *  https://timetableapi.ptv.vic.gov.au    The Swagger JSON file is available at http://timetableapi.ptv.vic.gov.au/swagger/docs/v3    Frequently asked questions are available on the PTV website at http://ptv.vic.gov.au/apifaq    Links to the following information are also provided on the PTV website at http://ptv.vic.gov.au/ptv-timetable-api/  * How to register for an API key and calculate a signature  * PTV Timetable API V2 to V3 Migration Guide  * Documentation for Version 2 of the PTV Timetable API  * PTV Timetable API Data Quality Statement    All information about how to use the API is in this documentation. PTV cannot provide technical support for the API.    Credits: This page has been based on Steve Bennett's http://opentransportdata.org/, used with permission.    # noqa: E501

    OpenAPI spec version: v3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ptvapi.api_client import ApiClient


class StopsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def stops_stop_details(self, stop_id, route_type, **kwargs):  # noqa: E501
        """View facilities at a specific stop (Metro and V/Line stations only)  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.stops_stop_details(stop_id, route_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int stop_id: Identifier of stop; values returned by Stops API (required)
        :param int route_type: Number identifying transport mode; values returned via RouteTypes API (required)
        :param bool stop_location: Indicates if stop location information will be returned (default = false)
        :param bool stop_amenities: Indicates if stop amenity information will be returned (default = false)
        :param bool stop_accessibility: Indicates if stop accessibility information will be returned (default = false)
        :param bool stop_contact: Indicates if stop contact information will be returned (default = false)
        :param bool stop_ticket: Indicates if stop ticket information will be returned (default = false)
        :param bool gtfs: Incdicates whether the stop_id is a GTFS ID or not
        :param bool stop_staffing: Indicates if stop staffing information will be returned (default = false)
        :param bool stop_disruptions: Indicates if stop disruption information will be returned (default = false)
        :param str token: Please ignore
        :param str devid: Your developer id
        :param str signature: Authentication signature for request
        :return: V3StopResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.stops_stop_details_with_http_info(stop_id, route_type, **kwargs)  # noqa: E501
        else:
            (data) = self.stops_stop_details_with_http_info(stop_id, route_type, **kwargs)  # noqa: E501
            return data

    def stops_stop_details_with_http_info(self, stop_id, route_type, **kwargs):  # noqa: E501
        """View facilities at a specific stop (Metro and V/Line stations only)  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.stops_stop_details_with_http_info(stop_id, route_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int stop_id: Identifier of stop; values returned by Stops API (required)
        :param int route_type: Number identifying transport mode; values returned via RouteTypes API (required)
        :param bool stop_location: Indicates if stop location information will be returned (default = false)
        :param bool stop_amenities: Indicates if stop amenity information will be returned (default = false)
        :param bool stop_accessibility: Indicates if stop accessibility information will be returned (default = false)
        :param bool stop_contact: Indicates if stop contact information will be returned (default = false)
        :param bool stop_ticket: Indicates if stop ticket information will be returned (default = false)
        :param bool gtfs: Incdicates whether the stop_id is a GTFS ID or not
        :param bool stop_staffing: Indicates if stop staffing information will be returned (default = false)
        :param bool stop_disruptions: Indicates if stop disruption information will be returned (default = false)
        :param str token: Please ignore
        :param str devid: Your developer id
        :param str signature: Authentication signature for request
        :return: V3StopResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['stop_id', 'route_type', 'stop_location', 'stop_amenities', 'stop_accessibility', 'stop_contact', 'stop_ticket', 'gtfs', 'stop_staffing', 'stop_disruptions', 'token', 'devid', 'signature']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method stops_stop_details" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'stop_id' is set
        if ('stop_id' not in params or
                params['stop_id'] is None):
            raise ValueError("Missing the required parameter `stop_id` when calling `stops_stop_details`")  # noqa: E501
        # verify the required parameter 'route_type' is set
        if ('route_type' not in params or
                params['route_type'] is None):
            raise ValueError("Missing the required parameter `route_type` when calling `stops_stop_details`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'stop_id' in params:
            path_params['stop_id'] = params['stop_id']  # noqa: E501
        if 'route_type' in params:
            path_params['route_type'] = params['route_type']  # noqa: E501

        query_params = []
        if 'stop_location' in params:
            query_params.append(('stop_location', params['stop_location']))  # noqa: E501
        if 'stop_amenities' in params:
            query_params.append(('stop_amenities', params['stop_amenities']))  # noqa: E501
        if 'stop_accessibility' in params:
            query_params.append(('stop_accessibility', params['stop_accessibility']))  # noqa: E501
        if 'stop_contact' in params:
            query_params.append(('stop_contact', params['stop_contact']))  # noqa: E501
        if 'stop_ticket' in params:
            query_params.append(('stop_ticket', params['stop_ticket']))  # noqa: E501
        if 'gtfs' in params:
            query_params.append(('gtfs', params['gtfs']))  # noqa: E501
        if 'stop_staffing' in params:
            query_params.append(('stop_staffing', params['stop_staffing']))  # noqa: E501
        if 'stop_disruptions' in params:
            query_params.append(('stop_disruptions', params['stop_disruptions']))  # noqa: E501
        if 'token' in params:
            query_params.append(('token', params['token']))  # noqa: E501
        if 'devid' in params:
            query_params.append(('devid', params['devid']))  # noqa: E501
        if 'signature' in params:
            query_params.append(('signature', params['signature']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'text/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v3/stops/{stop_id}/route_type/{route_type}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='V3StopResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def stops_stops_by_geolocation(self, latitude, longitude, **kwargs):  # noqa: E501
        """View all stops near a specific location  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.stops_stops_by_geolocation(latitude, longitude, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param float latitude: Geographic coordinate of latitude (required)
        :param float longitude: Geographic coordinate of longitude (required)
        :param list[int] route_types: Filter by route_type; values returned via RouteTypes API
        :param int max_results: Maximum number of results returned (default = 30)
        :param float max_distance: Filter by maximum distance (in metres) from location specified via latitude and longitude parameters (default = 300)
        :param bool stop_disruptions: Indicates if stop disruption information will be returned (default = false)
        :param str token: Please ignore
        :param str devid: Your developer id
        :param str signature: Authentication signature for request
        :return: V3StopsByDistanceResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.stops_stops_by_geolocation_with_http_info(latitude, longitude, **kwargs)  # noqa: E501
        else:
            (data) = self.stops_stops_by_geolocation_with_http_info(latitude, longitude, **kwargs)  # noqa: E501
            return data

    def stops_stops_by_geolocation_with_http_info(self, latitude, longitude, **kwargs):  # noqa: E501
        """View all stops near a specific location  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.stops_stops_by_geolocation_with_http_info(latitude, longitude, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param float latitude: Geographic coordinate of latitude (required)
        :param float longitude: Geographic coordinate of longitude (required)
        :param list[int] route_types: Filter by route_type; values returned via RouteTypes API
        :param int max_results: Maximum number of results returned (default = 30)
        :param float max_distance: Filter by maximum distance (in metres) from location specified via latitude and longitude parameters (default = 300)
        :param bool stop_disruptions: Indicates if stop disruption information will be returned (default = false)
        :param str token: Please ignore
        :param str devid: Your developer id
        :param str signature: Authentication signature for request
        :return: V3StopsByDistanceResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['latitude', 'longitude', 'route_types', 'max_results', 'max_distance', 'stop_disruptions', 'token', 'devid', 'signature']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method stops_stops_by_geolocation" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'latitude' is set
        if ('latitude' not in params or
                params['latitude'] is None):
            raise ValueError("Missing the required parameter `latitude` when calling `stops_stops_by_geolocation`")  # noqa: E501
        # verify the required parameter 'longitude' is set
        if ('longitude' not in params or
                params['longitude'] is None):
            raise ValueError("Missing the required parameter `longitude` when calling `stops_stops_by_geolocation`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'latitude' in params:
            path_params['latitude'] = params['latitude']  # noqa: E501
        if 'longitude' in params:
            path_params['longitude'] = params['longitude']  # noqa: E501

        query_params = []
        if 'route_types' in params:
            query_params.append(('route_types', params['route_types']))  # noqa: E501
            collection_formats['route_types'] = 'multi'  # noqa: E501
        if 'max_results' in params:
            query_params.append(('max_results', params['max_results']))  # noqa: E501
        if 'max_distance' in params:
            query_params.append(('max_distance', params['max_distance']))  # noqa: E501
        if 'stop_disruptions' in params:
            query_params.append(('stop_disruptions', params['stop_disruptions']))  # noqa: E501
        if 'token' in params:
            query_params.append(('token', params['token']))  # noqa: E501
        if 'devid' in params:
            query_params.append(('devid', params['devid']))  # noqa: E501
        if 'signature' in params:
            query_params.append(('signature', params['signature']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'text/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v3/stops/location/{latitude},{longitude}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='V3StopsByDistanceResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def stops_stops_for_route(self, route_id, route_type, **kwargs):  # noqa: E501
        """View all stops on a specific route  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.stops_stops_for_route(route_id, route_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int route_id: Identifier of route; values returned by Routes API - v3/routes (required)
        :param int route_type: Number identifying transport mode; values returned via RouteTypes API (required)
        :param int direction_id: An optional direction; values returned by Directions API. When this is set, stop sequence information is returned in the response.
        :param bool stop_disruptions: Indicates if stop disruption information will be returned (default = false)
        :param str token: Please ignore
        :param str devid: Your developer id
        :param str signature: Authentication signature for request
        :return: V3StopsOnRouteResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.stops_stops_for_route_with_http_info(route_id, route_type, **kwargs)  # noqa: E501
        else:
            (data) = self.stops_stops_for_route_with_http_info(route_id, route_type, **kwargs)  # noqa: E501
            return data

    def stops_stops_for_route_with_http_info(self, route_id, route_type, **kwargs):  # noqa: E501
        """View all stops on a specific route  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.stops_stops_for_route_with_http_info(route_id, route_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int route_id: Identifier of route; values returned by Routes API - v3/routes (required)
        :param int route_type: Number identifying transport mode; values returned via RouteTypes API (required)
        :param int direction_id: An optional direction; values returned by Directions API. When this is set, stop sequence information is returned in the response.
        :param bool stop_disruptions: Indicates if stop disruption information will be returned (default = false)
        :param str token: Please ignore
        :param str devid: Your developer id
        :param str signature: Authentication signature for request
        :return: V3StopsOnRouteResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['route_id', 'route_type', 'direction_id', 'stop_disruptions', 'token', 'devid', 'signature']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method stops_stops_for_route" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'route_id' is set
        if ('route_id' not in params or
                params['route_id'] is None):
            raise ValueError("Missing the required parameter `route_id` when calling `stops_stops_for_route`")  # noqa: E501
        # verify the required parameter 'route_type' is set
        if ('route_type' not in params or
                params['route_type'] is None):
            raise ValueError("Missing the required parameter `route_type` when calling `stops_stops_for_route`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'route_id' in params:
            path_params['route_id'] = params['route_id']  # noqa: E501
        if 'route_type' in params:
            path_params['route_type'] = params['route_type']  # noqa: E501

        query_params = []
        if 'direction_id' in params:
            query_params.append(('direction_id', params['direction_id']))  # noqa: E501
        if 'stop_disruptions' in params:
            query_params.append(('stop_disruptions', params['stop_disruptions']))  # noqa: E501
        if 'token' in params:
            query_params.append(('token', params['token']))  # noqa: E501
        if 'devid' in params:
            query_params.append(('devid', params['devid']))  # noqa: E501
        if 'signature' in params:
            query_params.append(('signature', params['signature']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'text/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v3/stops/route/{route_id}/route_type/{route_type}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='V3StopsOnRouteResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
