# coding: utf-8

"""
    PTV Timetable API - Version 3

    The PTV Timetable API provides direct access to Public Transport Victoria’s public transport timetable data.    The API returns scheduled timetable, route and stop data for all metropolitan and regional train, tram and bus services in Victoria, including Night Network(Night Train and Night Tram data are included in metropolitan train and tram services data, respectively, whereas Night Bus is a separate route type).    The API also returns real-time data for metropolitan train, tram and bus services (where this data is made available to PTV), as well as disruption information, stop facility information, and access to myki ticket outlet data.    This Swagger is for Version 3 of the PTV Timetable API. By using this documentation you agree to comply with the licence and terms of service.    Train timetable data is updated daily, while the remaining data is updated weekly, taking into account any planned timetable changes (for example, due to holidays or planned disruptions). The PTV timetable API is the same API used by PTV for its apps. To access the most up to date data PTV has (including real-time data) you must use the API dynamically.    You can access the PTV Timetable API through a HTTP or HTTPS interface, as follows:        base URL / version number / API name / query string  The base URL is either:    *  http://timetableapi.ptv.vic.gov.au  or    *  https://timetableapi.ptv.vic.gov.au    The Swagger JSON file is available at http://timetableapi.ptv.vic.gov.au/swagger/docs/v3    Frequently asked questions are available on the PTV website at http://ptv.vic.gov.au/apifaq    Links to the following information are also provided on the PTV website at http://ptv.vic.gov.au/ptv-timetable-api/  * How to register for an API key and calculate a signature  * PTV Timetable API V2 to V3 Migration Guide  * Documentation for Version 2 of the PTV Timetable API  * PTV Timetable API Data Quality Statement    All information about how to use the API is in this documentation. PTV cannot provide technical support for the API.    Credits: This page has been based on Steve Bennett's http://opentransportdata.org/, used with permission.    # noqa: E501

    OpenAPI spec version: v3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from ptvapi.models.v3_disruption_mode import V3DisruptionMode  # noqa: F401,E501
from ptvapi.models.v3_status import V3Status  # noqa: F401,E501


class V3DisruptionModesResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'disruption_modes': 'list[V3DisruptionMode]',
        'status': 'V3Status'
    }

    attribute_map = {
        'disruption_modes': 'disruption_modes',
        'status': 'status'
    }

    def __init__(self, disruption_modes=None, status=None):  # noqa: E501
        """V3DisruptionModesResponse - a model defined in Swagger"""  # noqa: E501

        self._disruption_modes = None
        self._status = None
        self.discriminator = None

        if disruption_modes is not None:
            self.disruption_modes = disruption_modes
        if status is not None:
            self.status = status

    @property
    def disruption_modes(self):
        """Gets the disruption_modes of this V3DisruptionModesResponse.  # noqa: E501

        Transport mode identifiers  # noqa: E501

        :return: The disruption_modes of this V3DisruptionModesResponse.  # noqa: E501
        :rtype: list[V3DisruptionMode]
        """
        return self._disruption_modes

    @disruption_modes.setter
    def disruption_modes(self, disruption_modes):
        """Sets the disruption_modes of this V3DisruptionModesResponse.

        Transport mode identifiers  # noqa: E501

        :param disruption_modes: The disruption_modes of this V3DisruptionModesResponse.  # noqa: E501
        :type: list[V3DisruptionMode]
        """

        self._disruption_modes = disruption_modes

    @property
    def status(self):
        """Gets the status of this V3DisruptionModesResponse.  # noqa: E501

        API Status / Metadata  # noqa: E501

        :return: The status of this V3DisruptionModesResponse.  # noqa: E501
        :rtype: V3Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this V3DisruptionModesResponse.

        API Status / Metadata  # noqa: E501

        :param status: The status of this V3DisruptionModesResponse.  # noqa: E501
        :type: V3Status
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V3DisruptionModesResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V3DisruptionModesResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
