# coding: utf-8

"""
    PTV Timetable API - Version 3

    The PTV Timetable API provides direct access to Public Transport Victoria’s public transport timetable data.    The API returns scheduled timetable, route and stop data for all metropolitan and regional train, tram and bus services in Victoria, including Night Network(Night Train and Night Tram data are included in metropolitan train and tram services data, respectively, whereas Night Bus is a separate route type).    The API also returns real-time data for metropolitan train, tram and bus services (where this data is made available to PTV), as well as disruption information, stop facility information, and access to myki ticket outlet data.    This Swagger is for Version 3 of the PTV Timetable API. By using this documentation you agree to comply with the licence and terms of service.    Train timetable data is updated daily, while the remaining data is updated weekly, taking into account any planned timetable changes (for example, due to holidays or planned disruptions). The PTV timetable API is the same API used by PTV for its apps. To access the most up to date data PTV has (including real-time data) you must use the API dynamically.    You can access the PTV Timetable API through a HTTP or HTTPS interface, as follows:        base URL / version number / API name / query string  The base URL is either:    *  http://timetableapi.ptv.vic.gov.au  or    *  https://timetableapi.ptv.vic.gov.au    The Swagger JSON file is available at http://timetableapi.ptv.vic.gov.au/swagger/docs/v3    Frequently asked questions are available on the PTV website at http://ptv.vic.gov.au/apifaq    Links to the following information are also provided on the PTV website at http://ptv.vic.gov.au/ptv-timetable-api/  * How to register for an API key and calculate a signature  * PTV Timetable API V2 to V3 Migration Guide  * Documentation for Version 2 of the PTV Timetable API  * PTV Timetable API Data Quality Statement    All information about how to use the API is in this documentation. PTV cannot provide technical support for the API.    Credits: This page has been based on Steve Bennett's http://opentransportdata.org/, used with permission.    # noqa: E501

    OpenAPI spec version: v3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V3VehiclePosition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'latitude': 'float',
        'longitude': 'float',
        'bearing': 'float',
        'supplier': 'str'
    }

    attribute_map = {
        'latitude': 'latitude',
        'longitude': 'longitude',
        'bearing': 'bearing',
        'supplier': 'supplier'
    }

    def __init__(self, latitude=None, longitude=None, bearing=None, supplier=None):  # noqa: E501
        """V3VehiclePosition - a model defined in Swagger"""  # noqa: E501

        self._latitude = None
        self._longitude = None
        self._bearing = None
        self._supplier = None
        self.discriminator = None

        if latitude is not None:
            self.latitude = latitude
        if longitude is not None:
            self.longitude = longitude
        if bearing is not None:
            self.bearing = bearing
        if supplier is not None:
            self.supplier = supplier

    @property
    def latitude(self):
        """Gets the latitude of this V3VehiclePosition.  # noqa: E501

        Geographic coordinate of latitude of the vehicle when known. May be null.              Only available for some bus runs.  # noqa: E501

        :return: The latitude of this V3VehiclePosition.  # noqa: E501
        :rtype: float
        """
        return self._latitude

    @latitude.setter
    def latitude(self, latitude):
        """Sets the latitude of this V3VehiclePosition.

        Geographic coordinate of latitude of the vehicle when known. May be null.              Only available for some bus runs.  # noqa: E501

        :param latitude: The latitude of this V3VehiclePosition.  # noqa: E501
        :type: float
        """

        self._latitude = latitude

    @property
    def longitude(self):
        """Gets the longitude of this V3VehiclePosition.  # noqa: E501

        Geographic coordinate of longitude of the vehicle when known.               Only available for some bus runs.  # noqa: E501

        :return: The longitude of this V3VehiclePosition.  # noqa: E501
        :rtype: float
        """
        return self._longitude

    @longitude.setter
    def longitude(self, longitude):
        """Sets the longitude of this V3VehiclePosition.

        Geographic coordinate of longitude of the vehicle when known.               Only available for some bus runs.  # noqa: E501

        :param longitude: The longitude of this V3VehiclePosition.  # noqa: E501
        :type: float
        """

        self._longitude = longitude

    @property
    def bearing(self):
        """Gets the bearing of this V3VehiclePosition.  # noqa: E501

        Compass bearing of the vehicle when known, clockwise from True North, i.e., 0 is North and 90 is East. May be null.              Only available for some bus runs.  # noqa: E501

        :return: The bearing of this V3VehiclePosition.  # noqa: E501
        :rtype: float
        """
        return self._bearing

    @bearing.setter
    def bearing(self, bearing):
        """Sets the bearing of this V3VehiclePosition.

        Compass bearing of the vehicle when known, clockwise from True North, i.e., 0 is North and 90 is East. May be null.              Only available for some bus runs.  # noqa: E501

        :param bearing: The bearing of this V3VehiclePosition.  # noqa: E501
        :type: float
        """

        self._bearing = bearing

    @property
    def supplier(self):
        """Gets the supplier of this V3VehiclePosition.  # noqa: E501

        Supplier of vehicle position data.  # noqa: E501

        :return: The supplier of this V3VehiclePosition.  # noqa: E501
        :rtype: str
        """
        return self._supplier

    @supplier.setter
    def supplier(self, supplier):
        """Sets the supplier of this V3VehiclePosition.

        Supplier of vehicle position data.  # noqa: E501

        :param supplier: The supplier of this V3VehiclePosition.  # noqa: E501
        :type: str
        """

        self._supplier = supplier

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V3VehiclePosition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V3VehiclePosition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
